# wxSocketBase Class Reference
[Networking]

`#include <wx/socket.h>`

Inheritance diagram for wxSocketBase:
[legend]

## Detailed Description

wxSocketBase is the base class for all socket-related objects, and it defines all basic IO functionality.

Note:
  When using wxSocket from multiple threads, even implicitly (e.g. by using wxFTP or wxHTTP in another thread) you must initialize the sockets from the main thread by calling Initialize() before creating the other ones.

## Events emitted by this class

The following event handler macros redirect the events to member function handlers 'func' with prototypes like:

void handlerFuncName(wxSocketEvent& event)
Event macros for events emitted by this class:

- EVT_SOCKET(id, func):
  Process a `wxEVT_SOCKET` event. See wxSocketEventFlags and wxSocketFlags for more info.

##

Library: wxNet

Category: Networking

See also:
  wxSocketEvent, wxSocketClient, wxSocketServer, Sockets Sample, wxSocketFlags, wxSocketEventFlags, wxSocketError

## Construction and Destruction
| wxSocketBase ()
| Default constructor.
virtual | ~wxSocketBase ()
| Destructor.
bool | Destroy ()
| Destroys the socket safely.
static bool | Initialize ()
| Perform the initialization needed in order to use the sockets.
static void | Shutdown ()
| Shut down the sockets.
## Public Member Functions
Socket State
bool | Error () const
| Returns true if an error occurred in the last IO operation.
virtual bool | GetLocal (wxSockAddress &addr) const
| Return the local address of the socket.
virtual bool | GetPeer (wxSockAddress &addr) const
| Return the peer address field of the socket.
long | GetTimeout () const
| Return the socket timeout in seconds.
bool | IsConnected () const
| Returns true if the socket is connected.
bool | IsData ()
| Check if the socket can be currently read or written.
bool | IsDisconnected () const
| Returns true if the socket is not connected.
bool | IsOk () const
| Returns true if the socket is initialized and ready and false in other cases.
wxUint32 | LastCount () const
| Returns the number of bytes read or written by the last IO call.
wxSocketError | LastError () const
| Returns the last wxSocket error.
void | RestoreState ()
| Restore the previous state of the socket, as saved with SaveState().
void | SaveState ()
| Save the current state of the socket in a stack.
Basic I/O
See also: wxSocketServer::WaitForAccept(), wxSocketClient::WaitOnConnect()
virtual bool | Close ()
| Shut down the socket, disabling further transmission and reception of data and disable events for the socket and frees the associated system resources.
void | ShutdownOutput ()
| Shuts down the writing end of the socket.
wxSocketBase & | Discard ()
| Delete all bytes in the incoming queue.
wxSocketFlags | GetFlags () const
| Returns current IO flags, as set with SetFlags().
void | InterruptWait ()
| Use this function to interrupt any wait operation currently in progress.
wxSocketBase & | Peek (void *buffer, wxUint32 nbytes)
| Peek into the socket by copying the next bytes which would be read by Read() into the provided buffer.
wxSocketBase & | Read (void *buffer, wxUint32 nbytes)
| Read up to the given number of bytes from the socket.
wxSocketBase & | ReadMsg (void *buffer, wxUint32 nbytes)
| Receive a message sent by WriteMsg().
void | SetFlags (wxSocketFlags flags)
| Use SetFlags to customize IO operation for this socket.
virtual bool | SetLocal (const wxIPV4address &local)
| Set the local address and port to use.
void | SetTimeout (long seconds)
| Set the default socket timeout in seconds.
wxSocketBase & | Unread (const void *buffer, wxUint32 nbytes)
| Put the specified data into the input queue.
bool | Wait (long seconds=-1, long millisecond=0)
| Wait for any socket event.
bool | WaitForLost (long seconds=-1, long millisecond=0)
| Wait until the connection is lost.
bool | WaitForRead (long seconds=-1, long millisecond=0)
| Wait until the socket is readable.
bool | WaitForWrite (long seconds=-1, long millisecond=0)
| Wait until the socket becomes writable.
wxSocketBase & | Write (const void *buffer, wxUint32 nbytes)
| Write up to the given number of bytes to the socket.
wxSocketBase & | WriteMsg (const void *buffer, wxUint32 nbytes)
| Sends a buffer which can be read using ReadMsg().
Handling Socket Events
void * | GetClientData () const
| Returns a pointer of the client data for this socket, as set with SetClientData().
void | Notify (bool notify)
| According to the notify value, this function enables or disables socket events.
void | SetClientData (void *data)
| Sets user-supplied client data for this socket.
void | SetEventHandler (wxEvtHandler &handler, int id=-1)
| Sets an event handler to be called when a socket event occurs.
void | SetNotify (wxSocketEventFlags flags)
| Specifies which socket events are to be sent to the event handler.

List of all members.

## Constructor & Destructor Documentation

wxSocketBase::wxSocketBase | ( |  | ) |

Default constructor.

Don't use it directly; instead, use wxSocketClient to construct a socket client, or wxSocketServer to construct a socket server.

virtual wxSocketBase::~wxSocketBase | ( |  | ) | `[virtual]`

Destructor.

Do not destroy a socket using the delete operator directly; use Destroy() instead. Also, do not create socket objects in the stack.

## Member Function Documentation

virtual bool wxSocketBase::Close | ( |  | ) | `[virtual]`

Shut down the socket, disabling further transmission and reception of data and disable events for the socket and frees the associated system resources.

Upon socket destruction, Close() is automatically called, so in most cases you won't need to do it yourself, unless you explicitly want to shut down the socket, typically to notify the peer that you are closing the connection.

Remarks:
  Although Close() immediately disables events for the socket, it is possible that event messages may be waiting in the application's event queue. The application must therefore be prepared to handle socket event messages even after calling Close().

Reimplemented in wxFTP.

bool wxSocketBase::Destroy | ( |  | ) |

Destroys the socket safely.

Use this function instead of the delete operator, since otherwise socket events could reach the application even after the socket has been destroyed. To prevent this problem, this function appends the wxSocket to a list of object to be deleted on idle time, after all events have been processed. For the same reason, you should avoid creating socket objects in the stack.

Destroy() calls Close() automatically.

Returns:
  Always true.

wxSocketBase& wxSocketBase::Discard | ( |  | ) |

Delete all bytes in the incoming queue.

This function always returns immediately and its operation is not affected by IO flags.

Use LastCount() to verify the number of bytes actually discarded.

If you use Error(), it will always return false.

bool wxSocketBase::Error | ( |  | ) | const

Returns true if an error occurred in the last IO operation.

Use this function to check for an error condition after one of the following calls: Discard(), Peek(), Read(), ReadMsg(), Unread(), Write(), WriteMsg().

void* wxSocketBase::GetClientData | ( |  | ) | const

Returns a pointer of the client data for this socket, as set with SetClientData().

wxSocketFlags wxSocketBase::GetFlags | ( |  | ) | const

Returns current IO flags, as set with SetFlags().

virtual bool wxSocketBase::GetLocal | ( | wxSockAddress & | addr | ) | const`[virtual]`

Return the local address of the socket.

Returns:
  true if no error happened, false otherwise.

virtual bool wxSocketBase::GetPeer | ( | wxSockAddress & | addr | ) | const`[virtual]`

Return the peer address field of the socket.

Returns:
  true if no error happened, false otherwise.

long wxSocketBase::GetTimeout | ( |  | ) | const

Return the socket timeout in seconds.

The timeout can be set using SetTimeout() and is 10 minutes by default.

static bool wxSocketBase::Initialize | ( |  | ) | `[static]`

Perform the initialization needed in order to use the sockets.

This function is called from wxSocket constructor implicitly and so normally doesn't need to be called explicitly. There is however one important exception: as this function must be called from the main (UI) thread, if you use wxSocket from multiple threads you must call Initialize() from the main thread before creating wxSocket objects in the other ones.

It is safe to call this function multiple times (only the first call does anything) but you must call Shutdown() exactly once for every call to Initialize().

This function should only be called from the main thread.

Returns:
  true if the sockets can be used, false if the initialization failed and sockets are not available at all.

void wxSocketBase::InterruptWait | ( |  | ) |

Use this function to interrupt any wait operation currently in progress.

Note that this is not intended as a regular way to interrupt a Wait call, but only as an escape mechanism for exceptional situations where it is absolutely necessary to use it, for example to abort an operation due to some exception or abnormal problem. InterruptWait is automatically called when you Close() a socket (and thus also upon socket destruction), so you don't need to use it in these cases.

See also:
  Wait(), WaitForLost(), WaitForRead(), WaitForWrite(), wxSocketServer::WaitForAccept(), wxSocketClient::WaitOnConnect()

bool wxSocketBase::IsConnected | ( |  | ) | const

Returns true if the socket is connected.

bool wxSocketBase::IsData | ( |  | ) |

Check if the socket can be currently read or written.

This might mean that queued data is available for reading or, for streamed sockets, that the connection has been closed, so that a read operation will complete immediately without blocking (unless the wxSOCKET_WAITALL flag is set, in which case the operation might still block).

bool wxSocketBase::IsDisconnected | ( |  | ) | const

Returns true if the socket is not connected.

bool wxSocketBase::IsOk | ( |  | ) | const

Returns true if the socket is initialized and ready and false in other cases.

Remarks:
  For wxSocketClient, IsOk() won't return true unless the client is connected to a server. For wxSocketServer, IsOk() will return true if the server could bind to the specified address and is already listening for new connections. IsOk() does not check for IO errors; use Error() instead for that purpose.

wxUint32 wxSocketBase::LastCount | ( |  | ) | const

Returns the number of bytes read or written by the last IO call.

Use this function to get the number of bytes actually transferred after using one of the following IO calls: Discard(), Peek(), Read(), ReadMsg(), Unread(), Write(), WriteMsg().

wxSocketError wxSocketBase::LastError | ( |  | ) | const

Returns the last wxSocket error.

See wxSocketError .

Note:
  This function merely returns the last error code, but it should not be used to determine if an error has occurred (this is because successful operations do not change the LastError value). Use Error() first, in order to determine if the last IO call failed. If this returns true, use LastError() to discover the cause of the error.

void wxSocketBase::Notify | ( | bool | notify | ) |

According to the notify value, this function enables or disables socket events.

If notify is true, the events configured with SetNotify() will be sent to the application. If notify is false; no events will be sent.

wxSocketBase& wxSocketBase::Peek | ( | void * | buffer,
|  | wxUint32 | nbytes |
| ) |  |  |

Peek into the socket by copying the next bytes which would be read by Read() into the provided buffer.

Peeking a buffer doesn't delete it from the socket input queue, i.e. calling Read() will return the same data.

Use LastCount() to verify the number of bytes actually peeked.

Use Error() to determine if the operation succeeded.

Parameters:

  | buffer | Buffer where to put peeked data.
  | nbytes | Number of bytes.

Returns:
  Returns a reference to the current object.

Remarks:
  The exact behaviour of Peek() depends on the combination of flags being used. For a detailed explanation, see SetFlags()

See also:
  Error(), LastError(), LastCount(), SetFlags()

wxSocketBase& wxSocketBase::Read | ( | void * | buffer,
|  | wxUint32 | nbytes |
| ) |  |  |

Read up to the given number of bytes from the socket.

Use LastCount() to verify the number of bytes actually read. Use Error() to determine if the operation succeeded.

Parameters:

  | buffer | Buffer where to put read data.
  | nbytes | Number of bytes.

Returns:
  Returns a reference to the current object.

Remarks:
  The exact behaviour of Read() depends on the combination of flags being used. For a detailed explanation, see SetFlags()

See also:
  Error(), LastError(), LastCount(), SetFlags()

wxSocketBase& wxSocketBase::ReadMsg | ( | void * | buffer,
|  | wxUint32 | nbytes |
| ) |  |  |

Receive a message sent by WriteMsg().

If the buffer passed to the function isn't big enough, the remaining bytes will be discarded. This function always waits for the buffer to be entirely filled, unless an error occurs.

Use LastCount() to verify the number of bytes actually read.

Use Error() to determine if the operation succeeded.

Parameters:

  | buffer | Buffer where to put read data.
  | nbytes | Size of the buffer.

Returns:
  Returns a reference to the current object.

Remarks:
  ReadMsg() will behave as if the wxSOCKET_WAITALL flag was always set and it will always ignore the wxSOCKET_NOWAIT flag. The exact behaviour of ReadMsg() depends on the wxSOCKET_BLOCK flag. For a detailed explanation, see SetFlags().

See also:
  Error(), LastError(), LastCount(), SetFlags(), WriteMsg()

void wxSocketBase::RestoreState | ( |  | ) |

Restore the previous state of the socket, as saved with SaveState().

Calls to SaveState() and RestoreState() can be nested.

See also:
  SaveState()

void wxSocketBase::SaveState | ( |  | ) |

Save the current state of the socket in a stack.

Socket state includes flags, as set with SetFlags(), event mask, as set with SetNotify() and Notify(), user data, as set with SetClientData(). Calls to SaveState and RestoreState can be nested.

See also:
  RestoreState()

void wxSocketBase::SetClientData | ( | void * | data | ) |

Sets user-supplied client data for this socket.

All socket events will contain a pointer to this data, which can be retrieved with the wxSocketEvent::GetClientData() function.

void wxSocketBase::SetEventHandler | ( | wxEvtHandler & | handler,
|  | int | id = `-1` |
| ) |  |  |

Sets an event handler to be called when a socket event occurs.

The handler will be called for those events for which notification is enabled with SetNotify() and Notify().

Parameters:

  | handler | Specifies the event handler you want to use.
  | id | The id of socket event.

See also:
  SetNotify(), Notify(), wxSocketEvent, wxEvtHandler

void wxSocketBase::SetFlags | ( | wxSocketFlags | flags | ) |

Use SetFlags to customize IO operation for this socket.

The flags parameter may be a combination of flags ORed together. Notice that not all combinations of flags affecting the IO calls (Read() and Write()) make sense, e.g. wxSOCKET_NOWAIT can't be combined with wxSOCKET_WAITALL nor with wxSOCKET_BLOCK.

The following flags can be used:

- wxSOCKET_NONE:
  Default mode: the socket will read some data in the IO calls and will process events to avoid blocking UI while waiting for the data to become available.
- wxSOCKET_NOWAIT:
  Don't wait for the socket to become ready in IO calls, read as much data as is available -- potentially 0 bytes -- and return immediately.
- wxSOCKET_WAITALL:
  Don't return before the entire amount of data specified in IO calls is read or written unless an error occurs. If this flag is not specified, the IO calls return as soon as any amount of data, even less than the total number of bytes, is processed.
- wxSOCKET_BLOCK:
  Don't process the UI events while waiting for the socket to become ready. This means that UI will be unresponsive during socket IO.
- wxSOCKET_REUSEADDR:
  Allows the use of an in-use port (wxServerSocket only).
- wxSOCKET_BROADCAST:
  Switches the socket to broadcast mode.
- wxSOCKET_NOBIND:
  Stops the socket from being bound to a specific adapter (normally used in conjunction with wxSOCKET_BROADCAST).

For more information on socket events see wxSocketFlags .

virtual bool wxSocketBase::SetLocal | ( | const wxIPV4address & | local | ) | `[virtual]`

Set the local address and port to use.

This function must always be called for the server sockets but may also be called for client sockets, if it is, bind() is called before connect().

void wxSocketBase::SetNotify | ( | wxSocketEventFlags | flags | ) |

Specifies which socket events are to be sent to the event handler.

The flags parameter may be combination of flags ORed together. The following flags can be used:

- wxSOCKET_INPUT_FLAG:
  to receive wxSOCKET_INPUT.
- wxSOCKET_OUTPUT_FLAG:
  to receive wxSOCKET_OUTPUT.
- wxSOCKET_CONNECTION_FLAG:
  to receive wxSOCKET_CONNECTION.
- wxSOCKET_LOST_FLAG:
  to receive wxSOCKET_LOST.

For example:

            sock.SetNotify(wxSOCKET_INPUT_FLAG | wxSOCKET_LOST_FLAG);
            sock.Notify(true);

In this example, the user will be notified about incoming socket data and whenever the connection is closed.

For more information on socket events see wxSocketEventFlags .

void wxSocketBase::SetTimeout | ( | long | seconds | ) |

Set the default socket timeout in seconds.

This timeout applies to all IO calls, and also to the Wait() family of functions if you don't specify a wait interval. Initially, the default timeout is 10 minutes.

static void wxSocketBase::Shutdown | ( |  | ) | `[static]`

Shut down the sockets.

This function undoes the call to Initialize() and must be called after every successful call to Initialize().

This function should only be called from the main thread, just as Initialize().

void wxSocketBase::ShutdownOutput | ( |  | ) |

Shuts down the writing end of the socket.

This function simply calls the standard shutdown() function on the underlying socket, indicating that nothing will be written to this socket any more.

wxSocketBase& wxSocketBase::Unread | ( | const void * | buffer,
|  | wxUint32 | nbytes |
| ) |  |  |

Put the specified data into the input queue.

The data in the buffer will be returned by the next call to Read().

This function is not affected by wxSocket flags.

If you use LastCount(), it will always return nbytes.

If you use Error(), it will always return false.

Parameters:

  | buffer | Buffer to be unread.
  | nbytes | Number of bytes.

Returns:
  Returns a reference to the current object.

See also:
  Error(), LastCount(), LastError()

bool wxSocketBase::Wait | ( | long | seconds = `-1`,
|  | long | millisecond = `0` |
| ) |  |  |

Wait for any socket event.

Possible socket events are:

- The socket becomes readable.
- The socket becomes writable.
- An ongoing connection request has completed (wxSocketClient only)
- An incoming connection request has arrived (wxSocketServer only)
- The connection has been closed.

Note that it is recommended to use the individual WaitForXXX() functions to wait for the required condition, instead of this one.

Parameters:

  | seconds | Number of seconds to wait. If -1, it will wait for the default timeout, as set with SetTimeout().
  | millisecond | Number of milliseconds to wait.

Returns:
  true when any of the above conditions is satisfied or false if the timeout was reached.

See also:
  InterruptWait(), wxSocketServer::WaitForAccept(), WaitForLost(), WaitForRead(), WaitForWrite(), wxSocketClient::WaitOnConnect()

bool wxSocketBase::WaitForLost | ( | long | seconds = `-1`,
|  | long | millisecond = `0` |
| ) |  |  |

Wait until the connection is lost.

This may happen if the peer gracefully closes the connection or if the connection breaks.

Parameters:

  | seconds | Number of seconds to wait. If -1, it will wait for the default timeout, as set with SetTimeout().
  | millisecond | Number of milliseconds to wait.

Returns:
  Returns true if the connection was lost, false if the timeout was reached.

See also:
  InterruptWait(), Wait()

bool wxSocketBase::WaitForRead | ( | long | seconds = `-1`,
|  | long | millisecond = `0` |
| ) |  |  |

Wait until the socket is readable.

This might mean that queued data is available for reading or, for streamed sockets, that the connection has been closed, so that a read operation will complete immediately without blocking (unless the wxSOCKET_WAITALL flag is set, in which case the operation might still block).

Notice that this function should not be called if there is already data available for reading on the socket.

Parameters:

  | seconds | Number of seconds to wait. If -1, it will wait for the default timeout, as set with SetTimeout().
  | millisecond | Number of milliseconds to wait.

Returns:
  Returns true if the socket becomes readable, false on timeout.

See also:
  InterruptWait(), Wait()

bool wxSocketBase::WaitForWrite | ( | long | seconds = `-1`,
|  | long | millisecond = `0` |
| ) |  |  |

Wait until the socket becomes writable.

This might mean that the socket is ready to send new data, or for streamed sockets, that the connection has been closed, so that a write operation is guaranteed to complete immediately (unless the wxSOCKET_WAITALL flag is set, in which case the operation might still block).

Notice that this function should not be called if the socket is already writable.

Parameters:

  | seconds | Number of seconds to wait. If -1, it will wait for the default timeout, as set with SetTimeout().
  | millisecond | Number of milliseconds to wait.

Returns:
  Returns true if the socket becomes writable, false on timeout.

See also:
  InterruptWait(), Wait()

wxSocketBase& wxSocketBase::Write | ( | const void * | buffer,
|  | wxUint32 | nbytes |
| ) |  |  |

Write up to the given number of bytes to the socket.

Use LastCount() to verify the number of bytes actually written.

Use Error() to determine if the operation succeeded.

Parameters:

  | buffer | Buffer with the data to be sent.
  | nbytes | Number of bytes.

Returns:
  Returns a reference to the current object.

Remarks:

The exact behaviour of Write() depends on the combination of flags being used. For a detailed explanation, see SetFlags().

See also:
  Error(), LastError(), LastCount(), SetFlags()

wxSocketBase& wxSocketBase::WriteMsg | ( | const void * | buffer,
|  | wxUint32 | nbytes |
| ) |  |  |

Sends a buffer which can be read using ReadMsg().

WriteMsg() sends a short header before the data so that ReadMsg() knows how much data should be actually read.

This function always waits for the entire buffer to be sent, unless an error occurs.

Use LastCount() to verify the number of bytes actually written.

Use Error() to determine if the operation succeeded.

Parameters:

  | buffer | Buffer with the data to be sent.
  | nbytes | Number of bytes to send.

Returns:
  Returns a reference to the current object.

Remarks:

WriteMsg() will behave as if the wxSOCKET_WAITALL flag was always set and it will always ignore the wxSOCKET_NOWAIT flag. The exact behaviour of WriteMsg() depends on the wxSOCKET_BLOCK flag. For a detailed explanation, see SetFlags().

See also:
  Error(), LastError(), LastCount(), SetFlags(), ReadMsg()

|  | [ top ]